#ifdef _WIN64
#pragma comment(lib, "..\\..\\..\\bin\\JZSearch\\x64\\JZSearchAPI.lib")
#else
#pragma comment(lib, "../lib/win32/JZSearchAPI.lib")
#endif

#include <cstdio>
#include <string>
#include <iostream>
#include <sstream>
#include "../API/JZSearchAPI.h"
#include <io.h>
#include <direct.h>

using namespace std;

const string rootDir = "D:\\NLPIR\\JZSearchInstall\\dict\\";//ʵŵַĵַиDataĿ¼
const string testFilesPath = rootDir + "../test/";//Եıļ·
const string indexDir = rootDir + "../indexfile/";//洢ĵַ
const string indexPath = indexDir + "JZSearch";//
const string fieldDir = rootDir + "../Field/";//ֶδ洢ĵַ
const string fieldPath = fieldDir + "field.dat";//ֶδ洢ļ
const int encoding = INDEX_ENCODING_GBK; // Ϣ
SEARCHER_HANDLE handle = -1;

enum SearchOption
{
	TopDirectoryOnly = 0,
	AllDirectories = 1,
};

void GetFiles(string folderPath, vector<string> &files, SearchOption op)
{
	_finddata_t FileInfo;
	string strfind = folderPath + "\\*";
	intptr_t Handle = _findfirst(strfind.c_str(), &FileInfo);

	if (Handle == -1L)
	{
		return;
	}
	do
	{
		//жǷĿ¼
		if (FileInfo.attrib & _A_SUBDIR)
		{
			//Ҫ
			if ((strcmp(FileInfo.name, ".") != 0) && (strcmp(FileInfo.name, "..") != 0))
			{
				string newPath = folderPath + "\\" + FileInfo.name;
				if (op == AllDirectories)
				{
					GetFiles(newPath, files, op);
				}
			}
		}
		else
		{
			files.push_back(folderPath + "\\" + FileInfo.name);
		}
	} while (_findnext(Handle, &FileInfo) == 0);
	_findclose(Handle);
}

vector<string> GetFiles(string folderPath, SearchOption op = AllDirectories)
{
	vector<string> files;
	GetFiles(folderPath, files, op);
	return files;
}

void CreateField()
{
	if (!_access(fieldDir.c_str(), _A_NORMAL))
	{
		_mkdir(fieldDir.c_str());
	}
	else
	{
		ostringstream ss;
		ss << "rm -rf " << "\"" << fieldDir << "\"";
		system(ss.str().c_str());

		if (_access(fieldDir.c_str(), _A_NORMAL))
		{
			printf("ֶʧ");
			return;
		}
	}

	// ʼҪ֤ȫִֻһ
	if (JZIndexer_Init(rootDir.c_str(), "", encoding, true) == 0)
	{
		printf("ʼʧ");
		return;
	}

	printf("ʼɹ");
	JZIndexer_FieldAdd("key", "", FIELD_TYPE_TEXT, true, true);
	JZIndexer_FieldAdd("value", "", FIELD_TYPE_TEXT, true, true);

	if (JZIndexer_FieldSave(fieldPath.c_str()))
	{
		printf("ֶι");
	}
	else
	{
		printf("ֶιʧ");
	}
	JZIndexer_Exit();
	printf("");
}

void StartIndex()
{
	if (!_access(indexDir.c_str(), _A_NORMAL))
	{
		_mkdir(indexDir.c_str());
	}
	else
	{
		ostringstream ss;
		ss << "rm -rf " << "\"" << indexDir << "\"";
		system(ss.str().c_str());

		if (_access(indexDir.c_str(), _A_NORMAL))
		{
			printf("ʧ");
			return;
		}
	}

	// 2µļ
	int flag = JZIndexer_Init(rootDir.c_str(), fieldPath.c_str(), encoding, 1); // ʼҪ֤ȫִֻһ

	if (flag == 0)
	{
		printf("JZIndexer_Initʼʧ");
		return;
	}

	printf("JZIndexer_Initʼɹ");

	JZSEARCH_HANDLE indexer = JZIndexer_NewInstance(indexPath.c_str());
	if (indexer<0)
	{
		printf("JZIndexerʵʧ");
		return;
	}
	printf("JZIndexerʵɹ");

	

	vector<string> files = GetFiles(testFilesPath, AllDirectories);
	JZSearch_SetIndexSizeLimit(-1);             // ǰø÷

	for (auto file : files)
	{
		string fileName = file.substr(file.find_last_of("\\") + 1);
		// string sContext = FileOperate.ReadFile(file);
		JZIndexer_MemIndexing(indexer,fileName.c_str(), "key", 0);
		// search.JZIndexer_MemIndexing(handle, sContext, "value", 0);
		JZIndexer_FileIndexing(indexer,file.c_str(), "value");

		if (JZIndexer_AddDoc(indexer) < 1)
		{
			printf("ʧܣ%s\n", fileName.c_str());
			return;
		}
		printf("ӳɹ%s\n", fileName.c_str());
	}
	JZIndexer_Save(indexer);
	JZIndexer_DeleteInstance(indexer);
	JZIndexer_Exit();
	printf("\n");
}

void StartSearch(string keyword = "")
{
	if (handle < 0)
	{
		// ʼҪ֤ȫִֻһ
		handle = JZSearch_Init(indexPath.c_str(), rootDir.c_str(), fieldPath.c_str(), 512000000, encoding, 0, true);
		if (handle < 0)
		{
			return;
		}

	}

	JZSEARCH_HANDLE  instance=JZSearcher_NewInstance(SORT_TYPE_RELEVANCE, handle);
	//ʵʧܣ򷵻Ϊ-1ΪʵHandleÿ߳ʹһʵ

	if (instance<0)
	{
		printf("JZSearcherʵʧܣ");
		return;
	}
	printf("JZSearcher_NewInstanceʵɹ");

	JZSearch_SetAbstractArgu(1000, "", "", 0);
	string query = "[cmd] listall";
	if (!keyword.empty())
	{
		printf("ʼԹؼ֡%s", keyword.c_str());
		ostringstream ss;
		ss << "[FIELD] * [OR] " << keyword << " [SORT] relevance";
		query = ss.str();
	}
	//string xml = searcher->Search(query.c_str(), 0, 10);
	const char *pResult = JZSearcher_Search(instance, query.c_str(), 0, 10);
	//query_line: ѯʽ
	//nStart:¼ʼַ
	//nPageCountǰҳؽĿ
	//ǰҳҪеĽjasonַ
	//const char *sResultXMLFile	ĬΪ0򣬴洢ļУadded in 2
	if (pResult!=0)
	{
		cout << pResult << endl;
	}

	JZSearcher_DeleteInstance(instance);//ͷʵ

	JZSearch_Exit();//ȫ˳Ҫʹ

}

int main(void)
{
	while (true)
	{
		printf("\nֶΣ룺0\n");
		printf("룺1\n");
		printf("룺2\n");
		printf("гݣ3\n");
		printf("˳룺\n");
		int input;
		cin >> input;

		switch (input)
		{
			case 0:
				CreateField();
				break;

			case 1:
				StartIndex();
				break;

			case 2:
			{
				printf("ݣ");
				string keyword;
				cin >> keyword;
				StartSearch(keyword);
				break;
			}

			case 3:
				StartSearch();
				break;

			default:
				return 1;
		}
	}
}